// fdir2xml.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "stdio.h"
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#include <windows.h>
#include <winbase.h>
#include <io.h>
#include <stdio.h>
#include <time.h>

#define PATH_MAX 512
#define MAX_FILES 1000

int indent_level = 1;

void process_folder(char *folder_path, char *folder_name);
void wstr2chars(LPCWSTR wstr, char *dest);

FILE *outf;

int _tmain(int argc, _TCHAR* argv[])
{
	if (argc != 3)
	{
		printf("Usage: fdir2xml folder_name output_file");
	}
	else
	{
		char outfname[999];
		wstr2chars(argv[2], outfname);

		outf = fopen(outfname, "w");
		if (outf == (FILE *) 0)
		{
			printf("Error: Can't open output file %s", outfname);
			return 0;
		}

		char fname[999];
		wstr2chars(argv[1], fname);
		process_folder(fname, fname);
	}
	fclose(outf);
	return 0;
}

void print_indents()
{
	int i;
	for (i = 0; i < indent_level; i++)
	{
		fprintf(outf, " ");
	}
}

void wstr2chars(LPCWSTR wstr, char *dest)
{
	int i = 0;
	do
	{
		dest[i] = (char) wstr[i];
		i++;
	} while(wstr[i] != 0);
	dest[i] = (char) 0;
}

void chars2wstr(char *src, WCHAR *dest)
{
	int i = 0;
	do
	{
		dest[i] = (WCHAR) src[i];
		i++;
	} while(src[i] != 0);
	dest[i] = (char) 0;
}


void process_folder(char *folder_path, char *folder_name)
{
	WIN32_FIND_DATA find_data; // Structure for results of Find* functions
	HANDLE find_result;        // A pointer to keep track of state of Find* functions
	char fname[999];
	char path_with_forward_slashes[999];

	strcpy(path_with_forward_slashes, folder_path);
	int i;
	i = 0;
	while (path_with_forward_slashes[i] != (char) 0)
	{
		if (path_with_forward_slashes[i] == '\\')
			path_with_forward_slashes[i] = '/';
		i++;
	}

	WCHAR wstr_path[999];

	print_indents();
	fprintf(outf, "<folder name=\"%s\">\n", folder_name);
	indent_level++;

	char search_path[999];
	strcpy(search_path, folder_path);
	strcat(search_path, "\\*");

	chars2wstr(search_path, wstr_path);

//	wstr_path = marshal_as<LPCWSTR>(search_path);



	/* Get a listing of all files in the outings folder. */
   find_result = FindFirstFile((LPCWSTR) wstr_path, &find_data);
	

	/* Loop through all the files in the outings folder */
	while (find_result != INVALID_HANDLE_VALUE)
	{

		wstr2chars(find_data.cFileName, fname);

		/* We're really only interested in subfolders. */
		if (strcmp(fname, ".") &&
			strcmp(fname, ".."))
		{

			if (find_data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				char new_folder[999];
				strcpy(new_folder, folder_path);
				//new_folder[strlen(new_folder)-1] = (char) 0;
				strcat(new_folder, "\\");
				strcat(new_folder, fname);
				process_folder(new_folder, fname);
			}
			else
			{
				print_indents();
				fprintf(outf, "<file source=\"%s/%s\"/>\n", path_with_forward_slashes, fname);
			}

		}
		/* Move on to the next file in the listing. */
		if (!FindNextFile(find_result, &find_data))
		{
			/* FindNextFile() failed.  We reached the end of the list. */
			/* Trigger our exit from the loop */
			FindClose(find_result);
			find_result = INVALID_HANDLE_VALUE;
		}
	}

	indent_level--;
	print_indents();
	fprintf(outf, "</folder>\n");
}
